#!/use/bin/env python3
from subprocess import CompletedProcess
import sys
from pathlib import Path
import os
from os.path import join
from mtlibs import process_helper
from dotenv import load_dotenv, find_dotenv
import logging


from .services.clash import startup_clash
from .services.mtxtun import startup_mtxtun
from .services.pf import startup_pf
import json
import traceback
from flask import Flask, request
import subprocess
import traceback
import shlex
import requests
import click
from flask import Flask
from flask.cli import with_appcontext
from flask.cli import FlaskGroup

import yaml
from .config import config  # 导入存储配置的字典

ENV_FILE = find_dotenv()
if ENV_FILE:
    load_dotenv(ENV_FILE)

logging.basicConfig(level=logging.DEBUG,
                    format='%(asctime)s - %(name)s - %(levelname)s - %(message)s')
logger = logging.getLogger(__name__)


data_dir = join(Path(__file__).parent, "data")


def create_app():
    app = Flask('wiki')
    # other setup
    return app

app = create_app()
app.config.from_object(config['development'])  # 获取相应的配置类

API_PREFIX = app.config.get("API_PREFIX", "/mtpapi")


from .admin import admin_blue
from .user import user_blue

app.register_blueprint(admin_blue)
app.register_blueprint(user_blue)

from .mtxp import mtxp_blue
app.register_blueprint(mtxp_blue)


@click.command()
def cli():
    logger.info("cli command")
    print("cli command")

# @app.cli.command("hello_command")
# @click.argument("ccurl")
# @with_appcontext
def entry_agent():
    """本地代理入口"""
    print("entry_agent", flush=True)
    ccurl = sys.argv[1]
    if ccurl:
        logger.info(f" 启动参数: {sys.argv} ")
        logger.info(f"ccurl : {ccurl}")
        logger.info(f"作为agent运行")
        def initAgent():
            config_url = f"{ccurl}/mtxp/tun_config"
            logger.info(f"config_url {config_url}")
            x = requests.get(config_url)
            jsonData= x.json()
            logger.info(f"配置数据 {jsonData}")
            # logger.info(f"启动端口转发")
            pf_items = jsonData["data"]["pf"]["items"]
            for item in pf_items:
                logger.info(f"启动一个端口转发 {item}")
                startup_pf(item["rhost"],item["rport"],item["lhost"], item["lport"])

        initAgent()
        app.run(debug=True, host='0.0.0.0', port=5500)

def entry():
    app.run(debug=True, host='0.0.0.0', port=5000)


def hello1():
    print("hello1")

@click.group(cls=FlaskGroup, create_app=create_app)
def cli2():
    print("cli111 callled")
    """Management script for the Wiki application."""